<?php

$cwd = getcwd();
if (preg_match("/^(.*\/)(services|system|admin|tmp\/admin)\/?$/", $cwd, $m)) $ROOTDIR = $m[1];
else $ROOTDIR = $cwd . "/";

if (isset($_GET['adei_session'])) $ADEI_SESSION = $_GET['adei_session'];
else $ADEI_SESSION = "00000000000000000000000000000000";

date_default_timezone_set("GMT"); 

require("config.php");
require("tools.php");

require("classes/profiler.php");

require("classes/request.php");
require("classes/options.php");
require("classes/database.php");
require("classes/datahandler.php");

require("classes/common.php");
require("classes/exception.php");
require("classes/lock.php");
require("classes/loggroup.php");
require("classes/interval.php");
require("classes/mask.php");
require("classes/resolution.php");
require("classes/data.php");

require("classes/reader.php");
require("classes/cache.php");
require("classes/draw.php");
require("classes/welcome.php");
require("classes/export.php");


//require("classes/zeus.php");

function adei_app($name, $opts=false, $throw=false) {
    global $ADEI_APP_PATH;
    
    if (isset($ADEI_APP_PATH[$name])) $appname = $ADEI_APP_PATH[$name];
    else $appname = $ADEI_APP_PATH["default"] . $name;

    if (!file_exists($appname)) {
	if ($throw) throw new ADEIException("Application \"$name\" is not installed");
	else return false;
    }
    
    if (!is_executable($appname)) {
	if ($throw) throw new ADEIException("Application \"$name\" is not executable");
	else return false;
    }
    
    return $appname . ($opts?(" " . $opts):"");
}

?>