<?php

/* 
    $limit > 0 - first <limit> elements
    $limit < 0 - last <limit> elements
*/

class RAWPoint implements Iterator {
 var $cache;
 var $ids;
 var $ivl;
 var $limit;

 var $res;
 var $key, $row;
 
 var $use_subseconds;
 var $postfix;
    
 function __construct(CACHEDB &$cache, MASK &$mask, INTERVAL &$ivl, $limit) {
    $this->cache = &$cache;

    $this->ids = &$mask->ids;
    if (!is_array($this->ids)) throw new ADEIException("Internal application error (MASK should be created using CACHE call)");

    $this->ivl = &$ivl;
    $this->limit = $limit;

    $this->use_subseconds = $cache->use_subseconds;
    $this->postfix = false;
 }

 function SetOption($option, $value) {
    $this->$option = $value;
 } 

 function SetOptions($options) {
    foreach ($options as $opt => &$value) {
	$this->$opt = $value;
    }
 }
 
 function rewind() {
    $list = "";

    foreach ($this->ids as $id) {
	$list .= "v$id AS v$id, ";
    }	

    $table = $this->cache->GetTableName(0, $this->postfix);

    $sql = $this->ivl->GetSQL($this->cache, $this->limit, $this->use_subseconds, isset($this->sequence)?$this->sequence:false);
    $list .= $sql['list'];
    $cond = &$sql['cond'];
    $sort = &$sql['sort'];
    $limit = &$sql['limit'];

    $this->res = mysql_query("SELECT $list FROM `$table` $cond $sort $limit", $this->cache->dbh);

    if (!$this->res)
	throw new ADEIException("SELECT request '$list $cond $sort $limit'  on CACHE table '$table' is failed...");

    $this->next();
 }
 
 function current() {
    return $this->row;
 }
 
 function key() {
    return $this->key;
 }
 
 function next() {
    $this->row = mysql_fetch_row($this->res);
    if ($this->row) {
	$lastkey = sizeof($this->row) - 1;
	if ($this->use_subseconds) {
	    $ns = $this->row[$lastkey];
	    
	    $extra = (9 - strlen($ns));
	    if ($extra) $ns = str_repeat('0', $extra) . $ns;
		
	    $this->key = $this->row[$lastkey-1] . ".$ns";
	    unset($this->row[$lastkey]);
	    unset($this->row[$lastkey-1]);
	} else {
	    $this->key = $this->row[$lastkey];
	    unset($this->row[$lastkey]);
	}
    } else {
	$this->key = false;
	mysql_free_result($this->res);
    }
 }

 function valid() {
    return $this->key?true:false;
 }
}

?>