<?php

$DEFAULT_PROPS = array (
	"db_mask" => 0,
	"experiment" => "0-0",
	"window" => "0"
);


class REQUESTList implements Iterator {
 var $props;
 var $list;
 var $cl;
 
 var $cur;
 
 function __construct(&$props, &$list, $cl = NULL) {
    $this->props = &$props;
    $this->list = &$list;

    $this->cur = false;
    
    if ($cl) $this->cl = &$cl;
    else $this->cl = "REQUEST";
 }
  
 function CreateDataRequest() {
    return new DATARequest($this->props);
 }
 
 function rewind() {
    reset($this->list);
    $this->cur = current($this->list);
 }
 
 function current() {
    $props = $this->props;
    foreach ($this->cur as $key => $value) {
	$props[$key] = $value;
    }
    return new $this->cl($props);
 }
 
 function key() {
    return key($this->list);
 }
 
 function next() {
    $this->cur = next($this->list);
 }

 function valid() {
    return $this->cur?true:false;
 }
}

class BASICRequest {
 var $props;

 function __construct(&$props = NULL) {
/*    $f = fopen("/tmp/xxx.props", "a+");
    fwrite($f, print_r($_GET, true));
    fwrite($f, print_r($_POST, true));
    fclose($f);*/
    
    if ($props) $this->props = $props;
    else {
	if (isset($_GET["db_server"])) $this->props = $_GET;
	else if (isset($_POST["db_server"])) $this->props = $_POST;
	else if (isset($_POST["props"])) return $this->props = json_decode(stripslashes($_POST['props']), true);
	else $this->props = array();
    }

/*		
    foreach ($DEFAULT_PROPS as $prop => $value) {
	if (!isset($this->props[$prop]))
	    $this->props[$prop] = $value;
    }	
*/
 }

}

class REQUEST extends BASICRequest {
 var $opts = false;
 var $opts_custom = false;
    
 const LIST_ALL = 1;
 const LIST_WILDCARDED = 2;

 const READER_FORBID_CACHEREADER = 1;
 
 function __construct(&$props = NULL) {
    global $DEFAULT_PROPS;

    parent::__construct($props);
 }

 function GetServerConfig() {
    global $READER_DB;
    
    if (isset($this->props['db_server'])) {
	$srvid = $this->props['db_server'];
	if (isset($READER_DB[$srvid]))
	    return $READER_DB[$srvid];
	else
	    throw new ADEIException(translate("Invalid server name is specified: \"%s\"", $srvid));    
    } else
	throw new ADEIException(translate("The data source server is not specified"));
 }

 function GetSourceList($flags = 0) {
    global $READER_DB;
    
    if ((($flags&REQUEST::LIST_ALL)==0)&&(isset($this->props['db_server']))) {
	$srvid = $this->props['db_server'];
	if (isset($READER_DB[$srvid])) {
	    $srvlist = array();
	    $srvlist[$srvid] = &$READER_DB[$srvid];
	} else throw new ADEIException(translate("Invalid server name is specified: \"%s\"", $srvid));
    } else {
	$srvlist = &$READER_DB;
    }
    
    $list = array();
    foreach ($srvlist as $srvid => &$srv) {
	if ((($flags&REQUEST::LIST_ALL)==0)&&(isset($this->props['db_name']))) {
	    $db = $this->props['db_name'];
	    $list[$srvid . "__" . $db] = array(
		'db_server' => $srvid,
		'db_name' => $db
	    );
	} else {
	    if ($flags&REQUEST::LIST_WILDCARDED) {
		if ($reader) $reader = &$rdr;
		else $reader = $this->CreateReader();
		$list = $reader->GetDatabaseList();
		foreach (array_keys($list) as $db) {
		    $list[$srvid . "__" . $db] = array(
			'db_server' => $srvid,
			'db_name' => $db
		    );
		}
		unset($reader);
	    } else {
		foreach ($srv['database'] as $db) {
		    $list[$srvid . "__" . $db] = array(
			'db_server' => $srvid,
			'db_name' => $db
		    );
		}
	    }
	}
    }
    
    return new REQUESTList($this->props, $list, "SOURCERequest");
 }
 
 function GetOptions() {
    if ($this->opts) return $this->opts;
    else {
	$this->opts = new OPTIONS($this);
	return $this->opts;
    }
 } 

 function GetGroupOptions(LOGGROUP &$grp = NULL) {
    if (($grp)&&($grp->gid != $this->props['db_group'])) {
	return $this->GetCustomOptions($this->props['db_server'], $this->props['db_name'], $grp->gid);
    }
    
    if (!$this->opts) {
	$this->opts = new OPTIONS($this);
    }
    
    return $this->opts;
 }

 function GetCustomOptions($server = false, $db = false, $group = false) {
    $id .= $server . "__" . $db . "__" . $group;
    
    if (!$this->opts_custom) $this->opts_custom = array();
    else if (isset($this->opts_custom[$id])) return $this->opts_custom[$id];

	
    $req = array();
    if ($server !== false) $req["db_server"] = $server;
    if ($db !== false) $req["db_name"] = $db;
    if ($group !== false) $req["db_group"] = $group;
    
    $this->opts_custom[$id] = new OPTIONS($req);
    return $this->opts_custom[$id];
 }

 function GetOption($prop, $default = NULL) {
    $opts = $this->GetOptions();
    return $opts->Get($prop, $default);
 }
 
 function GetGroupOption($prop, LOGGROUP &$grp = NULL, $default = NULL) {
    $opts = $this->GetGroupOptions($grp);
    return $opts->Get($prop, $default);
 }

 function GetCustomOption($prop, $server = false, $db = false, $group = false, $default = NULL) {
    $opts = $this->GetCustomOptions($server, $db, $group);
    return $opts->Get($prop, $default);
 }

 function GetQueryString(array &$ext = NULL) {
    $first = 1;
    $query = "";
    
    foreach (($ext?array_merge($this->props,$ext):$this->props) as $name => $value) {
	if ($first) $first = 0;
	else $query .= "&";
	
	$query .= $name . "=" . urlencode($value);
    }
    
    return $query;
 }
 
 function CheckServer() {
    if (!isset($this->props['db_server'])) return false;
    return true;
 }
 function CheckSource() {
    if (!$this->CheckServer()) return false;
    if (!isset($this->props['db_name'])) return false;
    return true;
 }
 function CheckGroup() {
    if (!$this->CheckSource()) return false;
    if (!isset($this->props['db_group'])) return false;
    return true;
 }
 function CheckData() {
    if (!$this->CheckGroup()) return false;
//    if (!isset($this->props['db_mask'])) return false;
    return true;
 }
 
 function CreateServerRequest() {
    return new SERVERRequest($this->props);
 }
 function CreateSourceRequest() {
    return new SOURCERequest($this->props);
 }
 function CreateGroupRequest() {
    return new GROUPRequest($this->props);
 }
 function CreateDataRequest() {
    return new DATARequest($this->props);
 }
}

class SERVERRequest extends REQUEST {
 var $srv;

 function __construct(&$props = NULL) {
    global $READER_DB;

    parent::__construct($props);
    
    if (isset($this->props["db_server"]))
	$srvid = $this->props["db_server"];
    else
	throw new ADEIException(translate("The data source server should be specified"));

    if (is_array($READER_DB[$srvid]))
	$this->srv = &$READER_DB[$srvid];
    else
	throw new ADEIException(translate("Invalid server identificator is supplied: \"%s\"", $srvid));
 }

 function GetServerInfo() {
    $server = $this->srv;
    if (isset($this->props['db_name'])) $server['database'] = $this->props['db_name'];
    else unset($server['database']);
    return $server;
 }
 
 function CreateReader($flags = 0) {
    if ($this->srv['disconnected']) {
	if ($flags&REQUEST::READER_FORBID_CACHEREADER)
	    throw new ADEIException(translate("The data reader(%s) is disconnected", $this->srv['reader']), ADEIException::DISCONNECTED);

	return $this->CreateCacheReader();
    } else if (($opts = $this->GetOptions())&&($opts->Get('use_cache_reader'))&&(!($flags&REQUEST::READER_FORBID_CACHEREADER))) {
	return $this->CreateCacheReader();
    } else {
	$reader = $this->srv['reader'];
    
	if (!include_once("readers/" . strtolower($reader) . '.php')) {
	    if ($this->srv['reader'])
		throw new ADEIException(translate("Unsupported data reader is configured: \"%s\"", $this->srv['reader']));
	    else
		throw new ADEIException(translate("The data reader is not configured"));
	}
    }

    try {
	$rdr = new $reader($this);
    } catch (ADEIException $ae) {
	if ($flags&REQUEST::READER_FORBID_CACHEREADER) throw $ae;

	if ($opts->Get('overcome_reader_faults')) {
	    $rdr = $this->CreateCacheReader();
	} else throw $ae;    
    }
    
    return $rdr;
 }
 
 function CreateCacheReader(CACHEDB &$cache = NULL) {
    return new CACHEReader($this, $cache);
 }

 function GetLocationString() {
    return "Server: \"" . $this->props['db_server'] . "\"";
 }
}


class SOURCERequest extends SERVERRequest {
 function __construct(&$props = NULL) {
    parent::__construct($props);

    if (!isset($this->props["db_name"]))
	throw new ADEIException(translate("The database should be specified"));
 }
 
 function GetGroupList(READER &$rdr = NULL, $flags = 0) {
    $list = array();
    
    if (isset($this->props['db_group'])) {
	$gid = $this->props['db_group'];
	$list[$gid] = array(
	    'db_group' => $gid,
	);
    } else {
	if ($rdr) $reader = &$rdr;
	else $reader = $this->CreateReader();
	$list = $reader->GetGroupList();
	foreach (array_keys($list) as $gid) {
	    $list[$gid] = array(
		'db_group' => $gid,
	    );
	}
    }
    return new REQUESTList($this->props, $list, "GROUPRequest");
 }
 function GetLocationString() {
    return "Server: \"" . $this->props['db_server'] . "\" Database: \"" . $this->props['db_name'] . "\"";
 }
}

class GROUPRequest extends SOURCERequest {
 function __construct(&$props = NULL) {
    parent::__construct($props);

    if (!isset($this->props["db_group"]))
	throw new ADEIException(translate("The Logging Group should be specified"));
 }

 function GetGroupInfo() {
    return $this->props;
 }
 
 function GetMaskInfo() {
    return $this->props;
 }
 
 function CreateGroup(READER &$rdr) {
    $ginfo = $this->GetGroupInfo();
    return $rdr->CreateGroup($ginfo);
 }

 function CreateCache(READER &$rdr = NULL) {
    return new CACHE($this, $rdr);
 }
 
 function CreateCacheUpdater(READER &$rdr = NULL) {
    return new CACHE($this, $rdr, CACHE::CREATE_UPDATER);
 }
 
 function GetLocationString() {
    return "Server: \"" . $this->props['db_server'] . "\" Database: " . $this->props['db_name'] . "\" Group: \"" . $this->props['db_group'] . "\"";
 }
}

class DATARequest extends GROUPRequest {
 function __construct(&$props = NULL) {
    parent::__construct($props);
 }

 function GetIntervalInfo() {
    return $this->props;
 }
 
 function CreateInterval(READER &$rdr = NULL, LOGGROUP &$grp = NULL, $flags = 0) {
    $iinfo = $this->GetIntervalInfo();
    return new INTERVAL($iinfo, $rdr, $grp, $flags);
 }
 
 function GetFormatInfo() {
    global $EXPORT_FORMATS;
    global $EXPORT_DEFAULT_FORMAT;
    
    $format = $this->props['format'];
    if ($format) {
	if ($EXPORT_FORMATS[$format])
	    return $EXPORT_FORMATS[$format];
	else
	    throw new ADEIException(translate("Unsupported export fromat (%s) is specified", $format));
    } else if ($EXPORT_FORMATS[$EXPORT_DEFAULT_FORMAT]) 
	return $EXPORT_FORMATS[$EXPORT_DEFAULT_FORMAT];
    else 
	return array(
    	    title => "CSV",
	    extension => "csv"
	);
 }
 
 function CreateExporter(STREAMHandler &$h = NULL) {
    if (!$h) $h = new STREAMHandler();

    $format = $this->GetFormatInfo();
    switch($format['type']) {
	case "handler":
	    if ($format['handler']) {
		if (!include_once("handlers/" . strtolower($format['handler']) . '.php')) {
	    	    throw new ADEIException(translate("Unsupported data handler is configured: \"%s\"", $format['handler']));
		}
		$handler = $format['handler'] . "Handler";
	    } else $handler = "CSVHandler";
	    
	    $handler = new $handler($h, $format['opts']);

	    return HANDLERExport($this, $handler, $format);
	break;
	case "filter":
	    return FILTERExport($this, $h, $format);
	break;
	default:
	    throw new ADEIException(translate("Unknown format type (%s)", $format['type']));
	
    }

    return new EXPORT($this, $h, $format);
 }
}


function adeiCreateExporter(STREAMHandler &$h = NULL) {
    $req = new DATARequest();
    return $req->CreateExporter($h);
}



/*

 
 function GetGroupList($flags) {
 }
 function GetGroupInfo() {
 }
 
 function GetIntervalInfo() {
 }
 
 function CreateCache() {
 }
 
 

*/
?>