<?php



/* DS: Rewrite with bcmath for 32bit system compatibility */
class MSTICKS {
 var $reader;
 var $correction;

 const START = 621355968000000000;
    
 function __construct(&$reader, $correction = 0) {
    $this->reader = &$reader;
    if (is_int($correction)) $this->correction = $correction;
    else $this->correction = 0;
 }
    
 function ImportTime($dt) {
    return (int)floor(10000000*$dt->format("U.u")) + MSTICKS::START - $this->correction;
 }
    
 function ExportTime($db_time) {
    global $adei_profiler;

    $ticks = ($db_time - MSTICKS::START + $this->correction);

    $ns100 = $ticks % 10000000;
    $timestamp =  ($ticks - $ns100) / 10000000;
	
    if ($ns100) {
	$len = strlen($ns100);
	if ($len < 7) $ns100 = str_repeat('0', 7 - $len) . $ns100;

        return new DateTime(strftime("%Y/%m/%d %H:%M:%S", $timestamp) . ".$ns100", $this->reader->gmt_timezone);
    } else {
	return new DateTime("@$timestamp", $this->reader->gmt_timezone);
    }
 }
}

?>