function selectUpdater(xmldoc, param) {
    // check errors
    var sel = param.select;

    var values = xmldoc.getElementsByTagName("Value");
    if (values.length > 0) {
	var value;
	var selnode = sel.node;
	
	while (selnode.hasChildNodes()) selnode.removeChild(selnode.firstChild);
		
	for (var i = 0; i < values.length; i++) {
	    var value = values[i];
	    var item_value = value.getAttribute("value");
	    var item_text = value.getAttribute("name");
	    if (!item_text) item_text = item_value;
	    
	    var opt = document.createElement('option');
	    opt.setAttribute("value", item_value);
	    if ((param.value)&&(item_value == param.value)) opt.setAttribute("selected", 1);
	    opt.appendChild(document.createTextNode(item_text));
	    selnode.appendChild(opt);
	}
/*
	innerHTML is not working due to the bug Q276228 in IE	
	sel.node.innerHTML = res;
*/
	if (sel.callback) {
	    sel.callback(sel.cbattr, sel.GetValue()/*values[0].getAttribute("value")*/, param.opts);
	}
    } else {
	var error;
	var errors = xmldoc.getElementsByTagName("Error");

	if (errors.length > 0)
	    error = errors[0].firstChild.data;
	else {
	    var errors = xmldoc.getElementsByTagName("parsererror");
	    if (errors.length > 0)
		error = errors[0].firstChild.data;
	    else
		error = "Empty response";
	}

	adeiReportError(translate("SELECT \"%s\" update is failed. Error: %s", sel.id, error));
    }
    
}


function SELECT(id, cb, cbattr) {
    if (typeof cb == "undefined") this.callback = null;
    else this.callback = cb;
    if (typeof cbattr == "undefined") this.cbattr = null;
    else this.cbattr = cbattr;

    this.id = id;
    this.node = document.getElementById(this.id);
    if (!this.node) adeiReportError(translate('SELECT "%s" is not found', this.id));
}

/* DS: Should do something if request failed */
SELECT.prototype.Update = function(url, opts, value) {
    var param = new Object;

    param.select = this;
    if (typeof opts == "undefined") param.opts = null;
    else param.opts = opts;
    if (typeof value == "undefined") param.value = null;
    else param.value = value;

    queueXML(url, selectUpdater, param);
}

SELECT.prototype.GetLastIndex = function() {
    return this.node.length - 1;
}

SELECT.prototype.GetValue = function(idx) {
    if (typeof idx == "undefined")
	return this.node.value
    else if ((idx < this.node.length)&&(idx>=0))
	return this.node[idx].value;

    adeiReportError(translate('SELECT "%s". Index (%i) is out of range', this.id, idx));
}

SELECT.prototype.GetIndex = function(value) {
    if (typeof value == "undefined")
	return this.node.selectedIndex;
    else {
	for (var i = 0; i < this.node.length; i++) {
	    if (this.node[i].value == value) {
		return i;
	    }
	}


	adeiReportError(translate('SELECT "%s". Accessing non-exisiting value: %s', this.id, value));
    }
}

SELECT.prototype.SetIndex = function(idx) {
    if ((idx < this.node.length)&&(idx >= 0))
	this.node.selectedIndex = idx;
    else
	adeiReportError(translate('SELECT "%s". Index (%i) is out of range', this.id, idx));
}

SELECT.prototype.SetValue = function(value) {
    for (var i = 0; i < this.node.length; i++) {
	if (this.node[i].value == value) {
	    this.node.selectedIndex = i;
	    return;
	}
    }
    
    adeiReportError(translate('SELECT "%s". Setting non-exisiting value: %s', this.id, value));
}

SELECT.prototype.GetTitle = function(idx) {
    if (typeof idx == "undefined")
	idx = this.node.selectedIndex;
    else if ((idx<0)||(idx>=this.node.length))
	return adeiReportError(translate('SELECT "%s". Index (%i) is out of range', this.id, idx));

    var node = this.node.childNodes[idx];
    if (node) {
	var text = node.firstChild;
	if (text) return text.nodeValue;
    }
    return null;
}

SELECT.prototype.Next = function(cycle, filter) {
    var cur = this.GetIndex();
    
    do {
	var idx = this.GetIndex() + 1;
	if (idx < this.node.length) this.SetIndex(idx);
	else if (cycle) this.SetIndex(0);
	else {
	    this.SetIndex(cur);
	    break;
	}
    } while ((typeof filter == "function")&&(filter(this.GetIndex(), this.GetValue())));
}

SELECT.prototype.Prev = function(cycle, filter) {
    var cur = this.GetIndex();

    do {
	var idx = this.GetIndex();
	if (idx > 0) this.SetIndex(idx - 1);
	else if (cycle) this.SetIndex(this.node.length - 1);
	else {
	    this.SetIndex(cur);
	    break;
	}
    } while ((typeof filter == "function")&&(filter(this.GetIndex(), this.GetValue())));
}

SELECT.prototype.Show = function() {
    if (this.node) this.node.style.display = "inline";
}

SELECT.prototype.Hide = function() {
    if (this.node) this.node.style.display = "none";
}
