function WINDOW_CONFIG() {
    this.width = 0;
/*    
    this.start = 0;
    this.end = 0;
    this.miny = 0;
    this.maxy = 0;
*/
}


function WINDOW(win_sel_id, start_id, end_id, ymin_id, ymax_id) {
    this.cfg = new WINDOW_CONFIG;
    this.props =  null;
    this.source_winsel = new SELECT(win_sel_id, windowUpdateWidth, this);

    this.sin = document.getElementById(start_id);
    if (!this.sin) alert("Custom window start time input field (\"" + start_id + "\") is not found");
    this.ein = document.getElementById(end_id);
    if (!this.ein) alert("Custom window end time input field (\"" + end_id + "\") is not found");
    this.minin = document.getElementById(ymin_id);
    if (!this.minin) alert("Custom window ymin input field (\"" + ymin_id + "\") is not found");
    this.maxin = document.getElementById(ymax_id);
    if (!this.maxin) alert("Custom window ymax input field (\"" + ymax_id + "\") is not found");
}

/*
WINDOW.prototype.SetSource = function(src) {
    this.src = src;
}

WINDOW.prototype.SetInterval = function(interval) {
    this.ivl = interval;
}
*/

WINDOW.prototype.SetConfig = function(config) {
    this.config = config;
}

WINDOW.prototype.SetUpdater = function(updater) {
    this.updater = updater;
}


WINDOW.prototype.RegisterGraph = function(graph) {
    // DS. Provide support for multiple attached graphs
    if (!this.graph) {
	this.graph = graph;
	if (!graph.window) graph.AttachWindow(this);
    }
}

WINDOW.prototype.Update = function(props, opts) {
    if (opts) {
	if (opts.reload) {
	    this.minval = false;
	    this.source_winsel.Update(adei.GetService("timewindow", props), opts, opts?opts.window_width:null);
	} else if ((opts.window_width)||(opts.reset)) {
	    if (!opts.window_width) opts.window_width = this.source_winsel.GetValue(0);

	    this.UpdateWidth(opts.window_width, opts);
	    
	    if ((opts.window_width)&&(this.source_winsel.GetValue() != opts.window_width))
		this.source_winsel.SetValue(opts.window_width);
	} else if (opt.confirm) {
	    this.config.Confirm(this);
	}
    }
}

WINDOW.prototype.UpdateWidth = function (value, opts) {
    if (!this.minval) {
	    // Setting minimal standard window
	var idx = this.source_winsel.GetLastIndex();
	this.minval = this.source_winsel.GetValue(idx - 1);
    }

    var reset_custom = true;
    
    if ((opts)&&(opts.window == "auto")) {
	this.SetCustomWindow(0,0,0,0);
	reset_custom = false;
    }
    
    if (((opts)&&(opts.reload))||(this.cfg.width != value)) {
        var css;
	var show = false;
    
    
	if (value < 0) {
	    if (this.cfg.width >= 0) {
		if ((reset_custom)&&((!opts)||(!opts.keep_custom))) {
		    this.sin.value = '';
		    this.ein.value = '';
		    this.minin.value = '';
		    this.maxin.value = '';
		}
	    
		cssShowClass('.hide_window_custom');
		
		if (!this.module_on_display) this.fix_hidden = true;


		if (typeof this.geometry_cb == "function") {
		    this.geometry_cb(this.geometry_cbattr);
		}
	    }
	} else {
	    if (this.cfg.width < 0) {
		cssHideClass('.hide_window_custom');

		if (!this.module_on_display) this.fix_hidden = true;
	    }
	    
	
	    if (this.cfg.width != value) show = true;
	}

	this.cfg.width = value;
    
    	if ((opts)&&(opts.confirm)) {
	    this.config.Confirm(this);
	}

	if (show) {
	    if ((typeof opts == "undefined")||((opts)&&(opts.apply))) this.Apply();
	}
    } else if ((opts)&&(opts.confirm)) {
	this.config.Confirm(this);
    }

}

WINDOW.prototype.UpdateRange = function() {
    if (this.graph) {
	this.graph.Clear();
    }
}

WINDOW.prototype.ApplyConfig = function(subcall) {
    if (this.config) {
	var sin, ein;
	var min, max;
	
	var width = this.cfg.width;
	
	if (width<0) {
	    var tmp = this.sin.value;
	    if (tmp) sin = adeiDateParse(tmp);
	    else sin = 0;
	    
	    tmp = this.ein.value;
	    if (tmp) ein = adeiDateParse(tmp);
	    else ein = 0;

	    tmp = this.minin.value;
	    if (tmp) minin = tmp;
	    else minin = 0;
	    
	    tmp = this.maxin.value;
	    if (tmp) maxin = tmp;
	    else maxin = 0;
	} else {
	    sin = 0; ein = 0;
	    minin = 0; maxin = 0;
	}
	
	this.config.SetWindow(width, sin, ein, minin, maxin);

	if (typeof subcall == "undefined") {
//	    alert('save');
	    this.config.Save();
	}
    }

    if (this.graph) this.graph.Clear();
}

WINDOW.prototype.ReadConfig = function(opts) {
    opts.window = "auto";
    opts.window_width = this.config.win_width;
//    this.SetCustomWindow(0,0,0,0);
}

WINDOW.prototype.Apply = function() {
    this.ApplyConfig();
    if (this.updater) this.updater.Update();
}

WINDOW.prototype.ResetX = function() {
	// We are reseting Y as well!
    this.source_winsel.SetValue(0);
    this.UpdateWidth(0);
}

WINDOW.prototype.ResetY = function() {
    this.config.win_min = 0;
    this.config.win_max = 0;

    this.SetCustomWindow(0,0,0,0);
    this.Apply();
}

WINDOW.prototype.SetCustomWindow = function (from, to, miny, maxy) {
    if ((from)||(to)||(miny)||(maxy)) {
	if ((from)||(to)) {
	    this.config.SetSelection(from, to);

	    this.sin.value = adeiDateFormat(from, adeiMathPreciseSubstract(to, from));
	    this.ein.value = adeiDateFormat(to, adeiMathPreciseSubstract(to, from));
	    
	} else {
	    this.config.SetSelection();
	    
	    if ((this.config.win_from)&&(this.config.win_to)&&(this.config.win_from!=this.config.win_to)) {
		this.sin.value = adeiDateFormat(this.config.win_from, this.config.win_to - this.config.win_from);
		this.ein.value = adeiDateFormat(this.config.win_to, this.config.win_to - this.config.win_from);
	    } else /*if (this.cfg.width >= 0)*/ {
		this.sin.value = adeiDateFormat(this.graph.xmin, this.graph.xmax - this.graph.xmin);
		this.ein.value = adeiDateFormat(this.graph.xmax, this.graph.xmax - this.graph.xmin);
	    } /*else {
	        this.sin.value = '';
		this.ein.value = '';
	    }*/
	}

	if ((miny)||(maxy)) {
	    this.minin.value = miny;
	    this.maxin.value = maxy;
	} else {
	    if (/*(this.config.win_min)&&(this.config.win_max)&&*/(this.config.win_min!=this.config.win_max)) {
	        this.minin.value = this.config.win_min;
		this.maxin.value = this.config.win_max;
	    } else {
	        this.minin.value = '';
		this.maxin.value = '';
	    }
	}

	this.UpdateWidth(-1, new Object({keep_custom: true}));
	this.source_winsel.SetValue(-1);
    } else {
	if (!this.config) return;
	
	this.config.SetSelection();

	if (this.config.win_width<0) {
	    if ((this.config.win_from)&&(this.config.win_to)&&(this.config.win_from!=this.config.win_to)) {
		this.sin.value = adeiDateFormat(this.config.win_from, this.config.win_to - this.config.win_from);
		this.ein.value = adeiDateFormat(this.config.win_to, this.config.win_to - this.config.win_from);
	    } else {
	        this.sin.value = '';
		this.ein.value = '';
	    }
	    
	    if (/*(this.config.win_min)&&(this.config.win_max)&&*/(this.config.win_min!=this.config.win_max)) {
	        this.minin.value = this.config.win_min;
		this.maxin.value = this.config.win_max;
	    } else {
	        this.minin.value = '';
		this.maxin.value = '';
	    }
	} else {
	    this.sin.value = '';
	    this.ein.value = '';
	    this.minin.value = '';
	    this.maxin.value = '';

	    this.UpdateWidth(this.config.win_width, new Object({keep_custom: true}));
	    this.source_winsel.SetValue(this.config.win_width);
	}
    }
}

WINDOW.prototype.Lock = function() {
    if ((this.graph)&&(this.cfg.width >= 0)) {
	var xmin = this.graph.xmin;
	var xmax = this.graph.xmax;
	if ((xmin)&&(xmax)) {
	    this.SetCustomWindow(xmin, xmax, 0, 0);
	    this.Apply();
	}
    }
}


WINDOW.prototype.MoveUp = function() {
    if (this.graph.yzoom) {
	var step_size = this.graph.ysize / adei.cfg.step_ratio;
	var min = this.graph.ymin + step_size;
	var max = this.graph.ymax + step_size;

	this.SetCustomWindow(0, 0, min, max);
    }
    this.Apply();    
}

WINDOW.prototype.MoveDown = function() {
    if (this.graph.yzoom) {
	var step_size = this.graph.ysize / adei.cfg.step_ratio;
	var min = this.graph.ymin - step_size;
	var max = this.graph.ymax - step_size;

	this.SetCustomWindow(0, 0, min, max);
    }
    this.Apply();    
}


WINDOW.prototype.MoveLeft = function() {
    if (this.graph.xmin > this.graph.imin) {
	var step_size = this.graph.xsize /  adei.cfg.step_ratio;
	var from = adeiMathPreciseSubstract(this.graph.xmin, step_size);

	if (from < this.graph.imin) {
	    step_size = adeiMathPreciseSubstract(this.graph.xmin, this.graph.imin);
	    from = this.graph.imin;
	}

	var to = adeiMathPreciseSubstract(this.graph.xmax, step_size);

	this.SetCustomWindow(from, to, 0, 0);
    }
    
    this.Apply();    
}

WINDOW.prototype.MoveRight = function() {
    if (this.graph.xmax < this.graph.imax) {
	var step_size = this.graph.xsize /  adei.cfg.step_ratio;
	var to = adeiMathPreciseAdd(this.graph.xmax, step_size);

	if ((this.graph.imax)&&(to > this.graph.imax)) {
	    step_size = adeiMathPreciseSubstract(this.graph.imax, this.graph.xmax);
	    to = this.graph.imax;
	}

	var from = adeiMathPreciseAdd(this.graph.xmin, step_size);

	this.SetCustomWindow(from, to, 0, 0);
    }

    this.Apply();    
}


WINDOW.prototype.Center = function(x, y) {
    var min = 0, max = 0;
    
    if (this.graph.yzoom) {
	var size = this.graph.ysize / 2;
	min = y - size;
	max = y + size;
    }

    var size = this.graph.xsize / 2;
    from = adeiMathPreciseSubstract(x, size);
    to = adeiMathPreciseAdd(x, size);
    
    if (from < this.graph.imin) {
	from = this.graph.imin;
	to = adeiMathPreciseAdd(x, adeiMathPreciseSubstract(x, this.graph.imin));
    } else if ((this.graph.imax)&&(to > this.graph.imax)) {
	from = adeiMathPreciseSubstract(x, adeiMathPreciseSubstract(this.graph.imax, x));
	to = this.graph.imax;
    }

    this.SetCustomWindow(from, to, min, max);
    this.Apply();    

}

WINDOW.prototype.IncreaseWidth = function() {
    var width = this.config.win_width;
    if (width < 0) {
	this.source_winsel.SetValue(0);
    } else {
	this.source_winsel.Prev(false);

/*	
	Updating All is not so bad idea 
	if (this.source_winsel.GetValue() == width) return;
*/
    }

//    this.cfg.width = this.source_winsel.GetValue();
    this.UpdateWidth(this.source_winsel.GetValue());
}

WINDOW.prototype.DecreaseWidth = function() {
    var width = this.config.win_width;
    if (width < 0) {
	var idx = this.source_winsel.GetLastIndex();
	if (idx > 0) this.source_winsel.SetIndex(idx - 1);
    } else {
	this.source_winsel.Next(false, function (idx, value) {
	    if (parseInt(value) < 0) return true;
	    return false;
	});

/*	
	Updating is not so bad idea
	    // Already minimum
	if (this.source_winsel.GetValue() == width) return;
*/

    }

//    this.cfg.width = this.source_winsel.GetValue();
    this.UpdateWidth(this.source_winsel.GetValue());
}

WINDOW.prototype.YZoomIn = function(y) {
    var new_size = this.graph.ysize / adei.cfg.zoom_ratio;

    if (typeof y == "undefined") {
	var diff = (this.graph.ysize - new_size) / 2;

	var min = this.graph.ymin + diff;
	var max = this.graph.ymax - diff;
    } else {
	var min = y - new_size/2;
	var max = y + new_size/2;
    }

    this.SetCustomWindow(0, 0, min, max);

    this.Apply();    
}

WINDOW.prototype.YZoomOut = function(y) {
    if (typeof y == "undefined") {
	var diff = (adei.cfg.zoom_ratio - 1) * this.graph.ysize / 2;

	var min = this.graph.ymin - diff;
	var max = this.graph.ymax + diff;
    } else {
	var new_size = this.graph.ysize * adei.cfg.zoom_ratio / 2;
	
	var min = y - new_size;
	var max = y + new_size;
    }

    this.SetCustomWindow(0, 0, min, max);

    this.Apply();    
}

WINDOW.prototype.CenterZoomIn = function() {
    var new_size = this.graph.xsize /  adei.cfg.zoom_ratio;
    var diff = adeiMathPreciseSubstract(this.graph.xsize, new_size) / 2;
    
    var from = adeiMathPreciseAdd(this.graph.xmin, diff);
    var to = adeiMathPreciseSubstract(this.graph.xmax, diff);
    
    this.SetCustomWindow(from, to, 0, 0);
    this.Apply();    
}

WINDOW.prototype.CenterZoomOut = function() {
    if ((this.graph.xmin)&&(this.graph.xmax)) {
	var diff = (adei.cfg.zoom_ratio - 1) * this.graph.xsize / 2;

	var from = adeiMathPreciseSubstract(this.graph.xmin, diff);
	var to = adeiMathPreciseAdd(this.graph.xmax, diff);
    } else {
	var xmin = this.config.win_from;
	var xmax = this.config.win_to;
	var xsize = adeiMathPreciseSubstract(xmax, xmin);

	var diff = (adei.cfg.zoom_ratio - 1) * xsize / 2;
	var from = adeiMathPreciseSubstract(xmin, diff);
	var to = adeiMathPreciseAdd(xmax, diff);
    }
    
    this.SetCustomWindow(from, to, 0, 0);
    this.Apply();    
}

WINDOW.prototype.DeepZoom = function(x) {
    var prec = this.graph.GetPrecision( adei.cfg.deepzoom_area);
    var from = adeiMathPreciseSubstract(x, prec);
    var to = adeiMathPreciseAdd(x, prec);
    
    this.SetCustomWindow(from, to, 0, 0);
    this.Apply();    
}

WINDOW.prototype.LocalZoomIn = function(x) {
    var new_size = this.graph.xsize /  (2 * adei.cfg.zoom_ratio);
    var from = adeiMathPreciseSubstract(x, new_size);
    var to = adeiMathPreciseAdd(x, new_size);
    
    this.SetCustomWindow(from, to, 0, 0);
    this.Apply();    
}

WINDOW.prototype.LocalZoomOut = function(x) {
    var diff = adei.cfg.zoom_ratio  * this.graph.xsize / 2;

    var from = adeiMathPreciseSubstract(x, diff);
    var to = adeiMathPreciseAdd(x, diff);
    
    this.SetCustomWindow(from, to, 0, 0);
    this.Apply();    
}


WINDOW.prototype.ZoomIn = function(x,y) {
    var width = this.config.win_width;
    if (width > 0) {
	var idx = this.source_winsel.GetLastIndex();
	if (this.source_winsel.GetIndex() == (idx - 1)) {
		// Minimal zoom is reached
	    this.LocalZoomIn(this.graph.xmax);
	    this.sub_edge_mode = true;
	} else {
    	    this.DecreaseWidth();
	}
	return;
    } else if (width == 0) {
	if (((this.graph.xmax - x)<=0)||((this.graph.xsize / (this.graph.xmax - x)) > adei.cfg.edge_ratio)) {
	    this.DecreaseWidth();
	    return;
	}
    }
    this.LocalZoomIn(x);    
}

WINDOW.prototype.ZoomOut = function(x,y) {
    var width = this.config.win_width;

    if (!width) return;

    if (width > 0) {
	this.IncreaseWidth();
	return;
    } else if (width < 0) {
	if ((this.sub_edge_mode)&&(((this.graph.xmax - x)<=0)||((this.graph.xsize / (this.graph.xmax - x)) > adei.cfg.edge_ratio))) {
	    if (this.graph.xsize < this.minval) {
		var new_size = adei.cfg.zoom_ratio  * this.graph.xsize;
		if (new_size > this.minval) {
			// Setting minmal width
		    this.DecreaseWidth();
		    return;
		}
	    }
	}

	var new_size = adei.cfg.zoom_ratio  * this.graph.xsize;
	if (new_size > Math.ceil(this.graph.imax - this.graph.imin)) {
	    this.source_winsel.SetValue(0);
	    this.UpdateWidth(0);
	
	    return ;
	}
    }

    
    this.CenterZoomOut();

/*
    Double operation is a bed idea, moved up

    if ((!this.graph.yzoom)&&(this.graph.xmin <= this.graph.imin)&&(this.graph.xmax >= this.graph.imax)) {
	this.source_winsel.SetValue(0);
	this.UpdateWidth(0);
	this.Apply();
    }
*/
}


WINDOW.prototype.NewGraph = function(xmin, xmax) {
    if (this.graph.xsize > this.minval) {
	this.sub_edge_mode = false;
    }
}


WINDOW.prototype.RegisterGeometryCallback = function(cb, cbattr) {
    this.geometry_cb = cb;
    this.geometry_cbattr = cbattr;
}

WINDOW.prototype.FixHidden = function() {
    if ((this.fix_hidden)&&(this.module_on_display)) {
	if (this.cfg.width<0) {
	    cssHideClass('.hide_window_custom');
	    cssShowClass('.hide_window_custom');
	} else {
	    cssShowClass('.hide_window_custom');
	    cssHideClass('.hide_window_custom');
	}
	this.fix_hidden = false;
    }
}

function windowUpdateWidth(window, value, opts) {
    window.UpdateWidth(value, opts);
}

function windowUpdateRange(window) {
    window.UpdateRange();
}

function windowUpdateRangeFunction(window) { 
    return function() { window.UpdateRange(); } 
}
